'CenterFrameVertically.csc
'Centers a frame between left and right margins.
'Copyright 2004 by Abe Hendin <venturadev@yourspeed.com>. Public domain.
'Version 1.1
'April 29, 2004

'VERSION HISTORY:
'VERSION 1.1, April 29, 2004
'Script now accounts for frame captions.

'VERSION 1.0, April 27, 2004
'First release

#ADDFOL "C:\Program Files\Corel\Ventura 10\Scripts"
#ADDFOL "C:\Program Files\Corel\Ventura 10\Ventura\Scripts"
#INCLUDE "scpconst.csi"
#INCLUDE "vpconst.csi"
#DEFINE APP_NAME				"CenterFrameVertically.csc"

#DEFINE FRAME_CAPTION_ABOVE				1
#DEFINE FRAME_CAPTION_BELOW				2
#DEFINE FRAME_CAPTION_ABOVE_AND_BELOW	3


WITHOBJECT "CorelVentura.Automation.10"
	DIM lSelectionType AS LONG
	DIM lFrameInd AS LONG, sFrameAnchorName AS STRING
	DIM lFrameHeight AS LONG, lSpaceMarginToFrame AS LONG, lFrameTop AS LONG
	DIM lCaptionType AS LONG
	DIM lFrameCap1Height AS LONG, lFrameCap2Height AS LONG
	DIM lFrameCap1Top AS LONG, lFrameCap2Top AS LONG
	DIM lPageHeight AS LONG, lTopMargin AS LONG, lBottomMargin as long
	DIM iretval AS INTEGER
	DIM bLeftPage AS BOOLEAN
	
	'confirm main (not caption) frame is selected
	lSelectionType = .GetSelectionType()
	IF lSelectionType <> SELECT_FRAME THEN
		iretval = MESSAGEBOX("This script is designed to center only main " + \\
			"(not caption) frames." + CHR(10) + \\
			"Please select a main frame and try again.", APP_NAME, MB_OK_ONLY + MB_STOP_ICON)
		STOP
	ENDIF
	
	'confirm that the frame selected is not a caption frame
	.FormatFrameAnchorGet , , , , sFrameAnchorName
	IF sFrameAnchorName = "" THEN
		iretval = MESSAGEBOX("This script is designed to center only main " + \\
			"(not caption) frames." + CHR(10) + \\
			"Please select a main frame and try again.", APP_NAME, MB_OK_ONLY + MB_STOP_ICON)
		STOP
	ENDIF
	
	lFrameInd = .CurrentFrameIndex() 'get ref to current frame
	'get page width and L/R margins
	.FrameFirst TRUE
	.FormatFrameGeneralGet , , , lPageHeight
	.CurrentPageNumber(bLeftPage) 'must test for pageside to get correct margins
	IF bLeftPage THEN
		.FormatFrameMarginsInsideGet 1, , , lTopMargin, lBottomMargin
	ELSE
		.FormatFrameMarginsInsideGet 2, , , lTopMargin, lBottomMargin
	ENDIF
	
	.FrameFirst FALSE, lFrameInd 'reselect frame
	
	'check for frame caption and make the calculations
	.FormatFrameGeneralGet , , , lFrameHeight, , , , lCaptionType
	SELECT CASE lCaptionType
		CASE FRAME_CAPTION_ABOVE
			.FrameFirst FALSE, lFrameInd+1
			.FormatFrameGeneralGet , , , lFrameCap1Height
			
			lFrameHeight = lFrameHeight + lFrameCap1Height
			lSpaceMarginToFrame = (lPageHeight - lTopMargin - lBottomMargin - lFrameHeight)/2
			lFrameTop = lTopMargin + lFrameCap1Height + lSpaceMarginToFrame
			
		CASE FRAME_CAPTION_BELOW
			.FrameFirst FALSE, lFrameInd+1
			.FormatFrameGeneralGet , , , lFrameCap1Height
			
			lFrameHeight = lFrameHeight + lFrameCap1Height
			lSpaceMarginToFrame = (lPageHeight - lTopMargin - lBottomMargin - lFrameHeight)/2
			lFrameTop = lTopMargin + lSpaceMarginToFrame
			
		CASE FRAME_CAPTION_ABOVE_AND_BELOW
			.FrameFirst FALSE, lFrameInd+1
			.FormatFrameGeneralGet , lFrameCap1Top, , lFrameCap1Height
			
			.FrameFirst FALSE, lFrameInd+2
			.FormatFrameGeneralGet , lFrameCap2Top, , lFrameCap2Height
			
			lFrameHeight = lFrameHeight + lFrameCap1Height + lFrameCap2Height
			lSpaceMarginToFrame = (lPageHeight - lTopMargin - lBottomMargin - lFrameHeight)/2
			
			'determine which caption is the CapAbove
			IF lFrameCap1Top < lFrameCap2Top THEN
				lFrameTop = lTopMargin + lFrameCap1Height + lSpaceMarginToFrame
			ELSE
				lFrameTop = lTopMargin + lFrameCap2Height + lSpaceMarginToFrame
			ENDIF
			
		CASE ELSE
			lSpaceMarginToFrame = (lPageHeight - lTopMargin - lBottomMargin - lFrameHeight)/2
			lFrameTop = lTopMargin + lSpaceMarginToFrame
	END SELECT
	
	'reposition frame
	IF lFrameHeight <= lPageHeight THEN
		'select and position frame
		.FrameFirst FALSE, lFrameInd
		.FormatFrameGeneral , lFrameTop
	ELSE
		iretval = MESSAGEBOX("Frame is taller than the page: cannot reposition.", \\
			"Processing parameters exceeded", \\
			MB_OK_ONLY + MB_STOP_ICON)
	ENDIF
END WITHOBJECT
